﻿Imports System.io

Public Class frmHello

    Private Sub cmdGetCameraImage_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles cmdGetCameraImage.Click
                            
        'StartTastenInaktiv

        'clear picture frames an bar code result
        Me.pbxCameraImageMod.Image=nothing
        Me.pbxCameraImage.Image=nothing
        Me.txtBarCodeResult.Text=""

        'new job: get picture from RoboTXT
        globJobSequenceNo=globJobSequenceNo+1
        globJobErrorRetry=0 'for JobFinisher
        Me.dgvJobList.Rows.Add(globJobSequenceNo,5,"waiting","get picture from RoboTXT",1000,now)

        'new job: show new picture
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,4,"waiting","show new picture",5000,now)

        'new job: delete all RoboTXT pictures on system
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,3,"waiting","delete all RoboTXT pictures on system",3000,now)

        'new job: analyse bar code
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,7,"waiting","analyse bar code from camera image",3000,now)

        'new job: pause
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,1,"waiting","pause",1000,now)

        'process pending events
        System.Windows.Forms.Application.DoEvents()

        'start dispatcher
        Me.tmrJobDispatcher.Enabled=true
    
    End Sub

    Private Sub Form1_Load( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles MyBase.Load
        
        'Fenster Einstellung maximal
        'Me.WindowState = FormWindowState.Maximized

        'Fensterüberschrift
        Me.Text = "RoboTXT warehousing " & Application.ProductVersion & " [freeware for non commercial use] " & Application.CompanyName

        'variable start definition
        globJobSequenceNo =0
        globJobActionID =0
        
    End Sub

    Private Sub cmdProgramEnd_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles cmdProgramEnd.Click
        end
    End Sub

    Private Function ShowRoboPicture(Dateiname As string) As boolean
        
        Dim fs As filestream

        ShowRoboPicture=false
        on Error GoTo ErrMarke
        
        'die komlizierte Bildanzeige auf Form1 ist erforderlich, weil bei einer anderen Methode die Bilddatei
        'gesperrt ist, wenn das Bild geladen wurde, das darf aber im vorliegenden Fall nicht passieren,
        'weil das nächste Bild mit selbem Dateinamen vom Controller kommen geschrieben werden soll
        fs = New FileStream (Application.StartupPath & "\" & Dateiname, filemode.Open, FileAccess.Read)
        Me.pbxCameraImage.Image=System.Drawing.Image.FromStream(fs)
        fs.Close

        'Debug.Print("OK")
        ShowRoboPicture=true
        Exit function

        ErrMarke: 
            'Es kommt häufiger vor, dass die bereitgestellten Bilder fehlerhaft sind
            on Error Resume next            
            ShowRoboPicture=false
            'Debug.Print("Fehler")
            fs.Close
            
    End Function

    Private Sub tmrJobFinisher_Tick( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles tmrJobFinisher.Tick
        
        If globJobActionID=5 then

            Dim myDir As New DirectoryInfo(Application.StartupPath)
            Dim myFiles() As FileInfo 
            Dim x As integer

            'Suchen nach gespeicherten Bilddateien
            myFiles = myDir.GetFiles("RoboTxtPic_*.jpg")
            If myFiles.Count=0 then
                'job is not done, no picture files detected
                
                globJobErrorWait=globJobErrorWait+1
                'write first row in JobList
                Me.dgvJobList.rows(0).Cells(2).value="error, retry " & globJobErrorRetry & "." & globJobErrorWait
                If globJobErrorWait>5 then
                    globJobErrorRetry=globJobErrorRetry+1
                    globJobErrorWait=0
                    Me.tmrJobFinisher.Enabled=false
                    Me.tmrJobWorker.Enabled=true
                End If
                If globJobErrorRetry>5 then
                    'stop retry
                    globJobActionID=0
                    globJobErrorRetry=0
                    Me.tmrJobFinisher.Enabled=false
                    'fire error message
                    x=msgbox("No access to camera data, check connection or restart RoboTXT and retry.",vbOKOnly+vbCritical,"Robo TXT Error")
                    'delete all waiting jobs
                    Me.dgvJobList.rows.Clear
                End If
            else
                'job is done, stop JobFinisher and remove job from JobList
                globJobActionID=0
                Me.tmrJobFinisher.Enabled=false
                Me.dgvJobList.Rows(0).Selected=true
                Me.dgvJobList.Rows.remove(Me.dgvJobList.SelectedRows(0))
                System.Windows.Forms.Application.DoEvents()

                'restart dispatcher
                Me.tmrJobDispatcher.Enabled=true
            End if


        End if 'globJobActionID=6

        
    End Sub

    Private Sub tmrJobDispatcher_Tick( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles tmrJobDispatcher.Tick

        If Me.dgvJobList.RowCount>0 then
            'stop dispatcher
            Me.tmrJobDispatcher.Enabled=false
            'write first row
            Me.dgvJobList.rows(0).Cells(2).value="processing"
            'read first row
            globJobActionID=Me.dgvJobList.rows(0).Cells(1).value
            'set delay time
            Me.tmrJobWorker.Interval=Me.dgvJobList.rows(0).Cells(4).value
            'start job worker
            Me.tmrJobWorker.Enabled=true
        End If

    End Sub

    Private Sub cmdCheckIP_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles cmdCheckIP.Click

        Dim Ergebnis As boolean
        'Debug.Print(ComputerIpStrg(Me.cboKanalAuswahl.Text))

        'Ping selected Computer
        Ergebnis=PingComputer(ComputerIpStrg(Me.cboKanalAuswahl.Text))

        If Ergebnis=True then
            Me.lblKanal.Text=Me.cboKanalAuswahl.Text & "  -  as active computer"
            Me.lblKanal.ForeColor=Color.Black
            IpAndresseZuGlobInt
            'gibt Schaltfläche frei für RoboTXT Zugriff
            StartTastenAktiv
        Else
            Me.lblKanal.Text="no active computer selected"
            Me.lblKanal.ForeColor=Color.Red
            'sperrt Schaltfläche für RoboTXT Zugriff
            StartTastenInaktiv
        End If

    End Sub

    Private Function PingComputer(ComputerIP As string) As boolean
        
        on Error goto err

        PingComputer = false
        If My.Computer.Network.Ping(ComputerIP) Then
            PingComputer = True
        End If

        Exit Function

        err:
            PingComputer = false

    End Function

    Private Function ComputerIpStrg (Kanal As string) As string

        Dim x As Integer

        x=Strings.InStr(Kanal,"  -  ")
        If x = 0 then
            ComputerIpStrg="error"
        else
            ComputerIpStrg=Strings.Left(Kanal, Strings.Len(Kanal)-x+4)
        End If

        'Debug.Print(Kanal)

    End Function

    Private Sub IpAndresseZuGlobInt

        Dim x1 As Integer
        Dim x2 As Integer
        Dim x3 As Integer

        x1=Strings.InStr(1,Me.lblKanal.text,".")
        x2=Strings.InStr(x1+1,Me.lblKanal.text,".")
        x3=Strings.InStr(x2+1,Me.lblKanal.text,".")
        x4=Strings.InStr(x3+1,Me.lblKanal.text,"  -  ")

        globIntIpAndresseA=Val(Strings.left(Me.lblKanal.text,x1))
        globIntIpAndresseB=Val(Strings.Mid(Me.lblKanal.text,x1+1,x2-x1))
        globIntIpAndresseC=Val(Strings.Mid(Me.lblKanal.text,x2+1,x3-x2))
        globIntIpAndresseD=Val(Strings.Mid(Me.lblKanal.text,x3+1,x4-x3))

        'Debug.Print(globIntIpAndresseA)
        'Debug.Print(globIntIpAndresseB)
        'Debug.Print(globIntIpAndresseC)
        'Debug.Print(globIntIpAndresseD)

    End Sub

    Private Sub cmdShowDigitalAll_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles cmdShowDigitalAll.Click

        'StartTastenInaktiv

        'new job: get digital input status I1...8
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,2,"waiting","get digital input status I1...8",500,now)

        'new job: pause
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,1,"waiting","pause",3000,now)
                
        'process pending events
        System.Windows.Forms.Application.DoEvents()

        'start dispatcher
        Me.tmrJobDispatcher.Enabled=true

    End Sub

    Private Sub tmrJobWorker_Tick( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles tmrJobWorker.Tick

        Dim Ergebnis As Object  'variant=object

        '*******************************************************************************************************
        '** Pause
        '*******************************************************************************************************
        If globJobActionID=1 then

            Me.tmrJobWorker.Enabled=false  
            globJobActionID=0
            
            'Debug.Print("globJobActionID=1 abgeschlosen")

            'job is done, remove it from JobList
            Me.dgvJobList.Rows(0).Selected=true
            Me.dgvJobList.Rows.remove(Me.dgvJobList.SelectedRows(0))
            System.Windows.Forms.Application.DoEvents()

            'restart dispatcher
            Me.tmrJobDispatcher.Enabled=true

        End If



        '*******************************************************************************************************
        '** alle Eingänge I1...8 digital auslesen und anzeigen
        '*******************************************************************************************************
        If globJobActionID=2 then

            Me.tmrJobWorker.Enabled=false
            globJobActionID=0
            
            Ergebnis=RoboTXT.TXT.GetDigitalAll(globIntIpAndresseA,globIntIpAndresseB,globIntIpAndresseC,globIntIpAndresseD)
            
            If Ergebnis>=128 then
                Ergebnis=Ergebnis-128
                Me.cbxI8digital.Checked=True
            Else
                Me.cbxI8digital.Checked=false
            End If

            If Ergebnis>=64 then
                Ergebnis=Ergebnis-64
                Me.cbxI7digital.Checked=True
            else
                Me.cbxI7digital.Checked=false
            End If

            If Ergebnis>=32 then
                Ergebnis=Ergebnis-32
                Me.cbxI6digital.Checked=True
            else
                Me.cbxI6digital.Checked=False
            End If

            If Ergebnis>=16 then
                Ergebnis=Ergebnis-16
                Me.cbxI5digital.Checked=True
            else
                Me.cbxI5digital.Checked=False
            End If

            If Ergebnis>=8 then
                Ergebnis=Ergebnis-8
                Me.cbxI4digital.Checked=True
            else
                Me.cbxI4digital.Checked=false
            End If

            If Ergebnis>=4 then
                Ergebnis=Ergebnis-4
                Me.cbxI3digital.Checked=True
            else
                Me.cbxI3digital.Checked=False
            End If

            If Ergebnis>=2 then
                Ergebnis=Ergebnis-2
                Me.cbxI2digital.Checked=True
            else
                Me.cbxI2digital.Checked=false
            End If

            If Ergebnis>=1 then
                Ergebnis=Ergebnis-1
                Me.cbxI1digital.Checked=True
            else
                Me.cbxI1digital.Checked=false
            End If

            'Debug.Print("globJobActionID=2 abgeschlosen")

            'job is done, remove it from JobList
            Me.dgvJobList.Rows(0).Selected=true
            Me.dgvJobList.Rows.remove(Me.dgvJobList.SelectedRows(0))
            System.Windows.Forms.Application.DoEvents()

            'restart dispatcher
            Me.tmrJobDispatcher.Enabled=true

        End If 'globJobActionID=2



        '*******************************************************************************************************
        '** alle Bilder von Festplatte löschen ("RoboTxtPic_*.jpg")
        '*******************************************************************************************************
        If globJobActionID=3 then
            
            Dim myDir As New DirectoryInfo(Application.StartupPath)
            Dim myFiles() As FileInfo 
            Dim DateinameBild As string

            Me.tmrJobWorker.Enabled=false
            globJobActionID=0

            'Durchzählen der vorhandenen Bilder und alle löschen
            myFiles = myDir.GetFiles("RoboTxtPic_*.jpg")
            For n As integer = 0 to myFiles.Length-1
                DateinameBild = myFiles(n).name
                'Debug.Print ("löschen: " & DateinameBild)
                myFiles(n).Delete
            Next

            'Debug.Print("globJobActionID=3 abgeschlosen")

            'job is done, remove it from JobList
            Me.dgvJobList.Rows(0).Selected=true
            Me.dgvJobList.Rows.remove(Me.dgvJobList.SelectedRows(0))
            System.Windows.Forms.Application.DoEvents()

            'restart dispatcher
            Me.tmrJobDispatcher.Enabled=true

        End  If 'globJobActionID=3



        '*******************************************************************************************************
        '** Bild von Festplatte in Picturepox übertragen
        '*******************************************************************************************************
        If globJobActionID=4 then

            Dim myDir As New DirectoryInfo(Application.StartupPath)
            Dim myFiles() As FileInfo 
            Dim DateinameBild As string

            Me.tmrJobWorker.Enabled=false
            globJobActionID=0
                            
            myFiles = myDir.GetFiles("RoboTxtPic_*.jpg")
        
            'Durchzählen der vorhandenen Bilder und das erste fehlerfreie Bild anzeigen
            'myFiles = myDir.GetFiles("RoboTxtPic_*.jpg")
            For n As integer = 0 to myFiles.Length-1
                DateinameBild = myFiles(n).name
                'Debug.Print (DateinameBild)
                'Bild anzeigen
                globErgebnis=ShowRoboPicture(DateinameBild)
                If globErgebnis=True then
                    'Abbruch for-next-Schleife
                    n=myFiles.Length-1
                End if
            Next
        
            'Debug.Print("globJobActionID=4 abgeschlosen")

            'job is done, remove it from JobList
            Me.dgvJobList.Rows(0).Selected=true
            Me.dgvJobList.Rows.remove(Me.dgvJobList.SelectedRows(0))
            System.Windows.Forms.Application.DoEvents()

            'restart dispatcher
            Me.tmrJobDispatcher.Enabled=true

        End if 'globJobActionID=4



        '*******************************************************************************************************
        '** Bilder vom Robo TXT Controller auf Festplatte übertragen
        '*******************************************************************************************************
        If globJobActionID=5 then

            Me.tmrJobWorker.Enabled=false
            'no reset of "globJobActionID=0", because JobFinisher will be used
            
            on Error Resume next

            Ergebnis=RoboTXT.TXT.GetPicture(globIntIpAndresseA,globIntIpAndresseB,globIntIpAndresseC,globIntIpAndresseD)
            'debug.Print("lade Bilder von Camera")

            'Debug.Print("globJobActionID=5 abgeschlosen")

            'start JobFinischer, to check if there picture files were stored
            Me.tmrJobFinisher.Interval=5000
            globJobErrorWait=0
            Me.tmrJobFinisher.Enabled=true

        End if 'globJobActionID=5



        '*******************************************************************************************************
        '** Digitale Ausgänge in RoboTXT setzen
        '*******************************************************************************************************
        If globJobActionID=6 then
            
            Me.tmrJobWorker.Enabled=false
            globJobActionID=0

            Dim Output as integer = 5   'O2 und O3
            Dim maxTime as integer = 15 '15s Laufzeit
            Dim Input1 as integer    'Abschaltung möglich über I7
            Dim Input2 as integer    'Abschaltung möglich über I8

            Output=0
            If Me.cbxO1digital.Checked=True then Output=Output+1
            If Me.cbxO2digital.Checked=True then Output=Output+2
            If Me.cbxO3digital.Checked=True then Output=Output+4
            If Me.cbxO4digital.Checked=True then Output=Output+8
            If Me.cbxO5digital.Checked=True then Output=Output+16
            If Me.cbxO6digital.Checked=True then Output=Output+32
            If Me.cbxO7digital.Checked=True then Output=Output+64
            If Me.cbxO8digital.Checked=True then Output=Output+128
            maxTime=Val(Strings.Left(me.cboDigitalOutMaxTime.Text,2))
            Input1=Val(Strings.Left(Me.cboDigitalOutInput1.Text,1))
            Input2=Val(Strings.Left(Me.cboDigitalOutInput2.Text,1))

            Ergebnis=RoboTXT.TXT.SetDigitalAll(Output,maxTime,Input1,Input2,globIntIpAndresseA,globIntIpAndresseB,globIntIpAndresseC,globIntIpAndresseD) 

            'Debug.Print("globJobActionID=6 abgeschlosen")
            
            'job is done, remove it from JobList
            Me.dgvJobList.Rows(0).Selected=true
            Me.dgvJobList.Rows.remove(Me.dgvJobList.SelectedRows(0))
            System.Windows.Forms.Application.DoEvents()

            'restart dispatcher
            Me.tmrJobDispatcher.Enabled=true
            
        End if 'globJobActionID=6


        '*******************************************************************************************************
        '** Bar Code analysieren
        '*******************************************************************************************************
        If globJobActionID=7 then

            Me.tmrJobWorker.Enabled=false
            globJobActionID=0
            
            'BarCode der Aufnahme analysieren
            Me.txtBarCodeResult.Text= ReadBarCode()

            'Debug.Print("globJobActionID=7 abgeschlosen")

            'job is done, remove it from JobList
            Me.dgvJobList.Rows(0).Selected=true
            Me.dgvJobList.Rows.remove(Me.dgvJobList.SelectedRows(0))
            System.Windows.Forms.Application.DoEvents()

            'restart dispatcher
            Me.tmrJobDispatcher.Enabled=true

        End if 'globJobActionID=7


    End Sub

    Sub StartTastenAktiv
        Me.cmdGetCameraImage.Enabled=true
        Me.cmdShowDigitalAll.Enabled=true
        Me.cmdShowSetDigitalAll.Enabled=true
    End Sub

    Sub StartTastenInaktiv
        Me.cmdGetCameraImage.Enabled=false
        Me.cmdShowDigitalAll.Enabled=false
        Me.cmdShowSetDigitalAll.Enabled=false
    End Sub

    Private Sub cmdShowSetDigitalAll_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles cmdShowSetDigitalAll.Click

        'StartTastenInaktiv

        'new job: get digital input status I1...8
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,6,"waiting","set digital output status O1...8 for max. " & Me.cboDigitalOutMaxTime.text,500,now)

        'new job: pause
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,1,"waiting","pause",3000,now)
                
        'process pending events
        System.Windows.Forms.Application.DoEvents()

        'start dispatcher
        Me.tmrJobDispatcher.Enabled=true
        
    End Sub

    Private Function ReadBarCode()

        on Error Resume next

        Dim ImageHeight As Integer
        Dim ImageWidth As integer
        Dim h As Integer
        Dim v As integer
        Dim m As Integer                            'mehrfach als Zähler verwendet
        Dim n As Integer                            'mehrfach als Zähler verwendet
        Dim PixelColor As System.Drawing.Color
        Dim ColorAveage As integer
        Dim ColorRed As Integer
        Dim ColorGreen As Integer
        Dim ColorBlue As integer
        Dim PatternData(330,25) as Integer
        Dim ArrayPointer As integer
        Dim ChangeCounter As Integer
        Dim ConstantColorCounter as integer
        Dim PixelColorOld As System.Drawing.color
        Dim PixelColorNow As System.Drawing.color
        Dim PixelCount As integer 
        Dim BarWidth As single        'einfache Gleitkommazahl
        Dim BarNew As integer
        Dim BarCodeCollection As string
        Dim BarCodePart1 As string
        Dim BarCodePart2 As string
        Dim BarCodePart3 As string
        Dim BarCodePart4 As string
        Dim BarCodeResult(25) As integer

        'Schritt 1: Bild kopieren in pbxCameraImageMod, allerdings als Bitmap.
        '           Hierbei wird eine Konvertierung aus jpg nach bmp vorgenommen
        PicBitmap = new Bitmap(Me.pbxCameraImage.Image)
        Me.pbxCameraImageMod.Image=PicBitmap

        'Schritt 2: Anzahl Bildpunkte analysieren, horizontal und Vertikal
        ImageHeight=Me.pbxCameraImage.Image.Height
        ImageWidth=Me.pbxCameraImage.Image.Width
        'Debug.Print ("ImageHeight=" & ImageHeight & "  ImageWidth=" & ImageWidth)

        'Schritt 3: Bildpunktumformung auf schwarz-weiss gemäß eingestelltem Schwellenwert
        For h=0 to ImageHeight-1        'horizontal durchzählen
            For v=0 to ImageWidth-1     'vertikal durchzählen
                'Pixelfarbe analysieren
                PixelColor=PicBitmap.GetPixel(v,h)
                ColorRed = PixelColor.R 
                ColorGreen = PixelColor.G
                ColorBlue = PixelColor.B
                'Helligkeitsmittelwert aus den 3 Farben berechnen
                ColorAveage=(ColorRed + ColorGreen + ColorBlue)/3
                'Debug.Print (ColorAveage)
                If ColorAveage < Me.trbLevelBW.Value then
                    'Punkt schwarz einfärben
                    PicBitmap.SetPixel(v,h,Color.Black)
                else
                    'Punkt weiss einfärben
                    PicBitmap.SetPixel(v,h,Color.White)
                End If
                'Debug.Print(PixelColor.R & " " & PixelColor.G & " " & PixelColor.B)
            Next
        Next

        'Schritt 4: Streifenmuster erfassen horizontal und vertikal und Speicherung in array PatternData(x,y)
        ArrayPointer=1
        'Einlesen vertikale Streifen
        For v=10 to ImageWidth-1 Step 30
            ChangeCounter=0
            ConstantColorCounter=0
            For h=0 to ImageHeight-1
                If h=0 then
                    PixelColorOld=PicBitmap.GetPixel(v,h)
                else
                    PixelColorNow=PicBitmap.GetPixel(v,h)
                    If PixelColorOld=PixelColorNow then
                        ConstantColorCounter=ConstantColorCounter+1
                    Else
                        PatternData(ChangeCounter,ArrayPointer)=ConstantColorCounter
                        PatternData(0,ArrayPointer)=ChangeCounter
                        'Debug.Print ("ChangeCounter=" & ChangeCounter & " ArrayPointer=" & ArrayPointer & " ConstantColorCounter=" & ConstantColorCounter)
                        ConstantColorCounter=0
                        ChangeCounter=ChangeCounter+1
                        PixelColorOld=PixelColorNow
                    End if
                End If
                'PicBitmap.SetPixel(v,h,Color.Red)
            Next
            PatternData(0,0)=ArrayPointer
            ArrayPointer=ArrayPointer+1
        Next
        'Einlesen horizontale Streifen
        For h=7 to ImageHeight-1 Step 28
            ChangeCounter=0
            ConstantColorCounter=0
            For v=0 to ImageWidth-1
                If v=0 then
                    PixelColorOld=PicBitmap.GetPixel(v,h)
                else
                    PixelColorNow=PicBitmap.GetPixel(v,h)
                    If PixelColorOld=PixelColorNow then
                        ConstantColorCounter=ConstantColorCounter+1
                    Else
                        PatternData(ChangeCounter,ArrayPointer)=ConstantColorCounter
                        PatternData(0,ArrayPointer)=ChangeCounter
                        'Debug.Print ("ChangeCounter=" & ChangeCounter & " ArrayPointer=" & ArrayPointer & " ConstantColorCounter=" & ConstantColorCounter)
                        ConstantColorCounter=0
                        ChangeCounter=ChangeCounter+1
                        PixelColorOld=PixelColorNow
                    End if
                End If
                'PicBitmap.SetPixel(v,h,Color.Green)
            Next
            PatternData(0,0)=ArrayPointer
            ArrayPointer=ArrayPointer+1
        Next
        'Debug.Print("ArrayPointer=" & ArrayPointer)

        'Schritt 5: array PatternData(x,y) der Farbänderungen aller ausgelesenen Streifen untersuchen
        BarCodeResult(0)=0
        For m=1 to PatternData(0,0)
            'Debug.Print("m=" & m & " PatternData(0,m)=" & PatternData(0,m))
            PixelCount=0
            BarCodeCollection=""
            For n=1 to PatternData(0,m) 'Diese Schleife enthält alle verwertbaren Daten
                'Debug.Print ("n=" & n & " m=" & m & " PatternData=" & PatternData(n,m))
                'Berechnung der Gesamtbarcodebreite
                PixelCount=PixelCount+PatternData(n,m)
                BarWidth=Int((PixelCount/51)+0.5)
            next
            If BarWidth=0 then BarWidth=1
            For n=1 to PatternData(0,m) 'Diese Schleife enthält alle verwertbaren Daten
                BarNew=Int(PatternData(n,m)/BarWidth)
                If BarNew=3 then BarNew=2
                If BarNew=0 then BarNew=1
                BarCodeCollection=BarCodeCollection & "" & BarNew
            next
            'Debug.Print("PixelCount=" & PixelCount)
            'Debug.Print("BarWidth=" & BarWidth)
            'Debug.Print("BarCodeCollection=" & BarCodeCollection)
            BarCodePart1=resultEncoder(Strings.mid(BarCodeCollection,1,9))
            BarCodePart2=resultEncoder(Strings.mid(BarCodeCollection,11,9))
            BarCodePart3=resultEncoder(Strings.mid(BarCodeCollection,21,9))
            BarCodePart4=resultEncoder(Strings.mid(BarCodeCollection,31,9))
            'Debug.Print("BarCodePart1=" & BarCodePart1)
            'Debug.Print("BarCodePart2=" & BarCodePart2)
            'Debug.Print("BarCodePart3=" & BarCodePart3)
            'Debug.Print("BarCodePart4=" & BarCodePart4)

            If BarCodePart1<>"error" and BarCodePart2<>"error" and BarCodePart3<>"error" and BarCodePart4<>"error" then
                'Debug.Print(Strings.left(BarCodePart1,1))
                if Strings.left(BarCodePart1,1)="R" then 
                    'Code was read in forward direction
                    'Debug.Print("reverse")
                    BarCodeResult(0)=BarCodeResult(0)+1
                    BarCodeResult(BarCodeResult(0))=strings.Right(BarCodePart4,1) & strings.Right(BarCodePart3,1) & strings.Right(BarCodePart2,1) & strings.Right(BarCodePart1,1)
                Else
                    'Code was read in reverse direction
                    'Debug.Print("forward")
                    BarCodeResult(0)=BarCodeResult(0)+1
                    BarCodeResult(BarCodeResult(0))=strings.Right(BarCodePart1,1) & strings.Right(BarCodePart2,1) & strings.Right(BarCodePart3,1) & strings.Right(BarCodePart4,1)
                End If
                Debug.Print("BarCodeResult(" & BarCodeResult(0) & ")=" & BarCodeResult(BarCodeResult(0)))
            End If
            
        next

        'Schritt 6: Ergebnisse aus BarCodeResult(x) auswerten
        ReadBarCode="no bar code detected"
        If BarCodeResult(0)=0 then 
            ReadBarCode="no bar code detected"
        End If
        If BarCodeResult(0)=1 then 
            ReadBarCode=BarCodeResult(1)
        End If
        If BarCodeResult(0)=2 then 
            If BarCodeResult(1)=BarCodeResult(2)
                ReadBarCode=BarCodeResult(1)
            else
                ReadBarCode="bar code with errors detected"
            End if
        End If
        If BarCodeResult(0)=3 then 
            If BarCodeResult(1)=BarCodeResult(2) and BarCodeResult(1)=BarCodeResult(3) then
                ReadBarCode=BarCodeResult(1)
            else
                ReadBarCode="bar code with errors detected"
            End if
        End If
        If BarCodeResult(0)=4 then 
            If BarCodeResult(1)=BarCodeResult(2) and BarCodeResult(1)=BarCodeResult(3) and BarCodeResult(1)=BarCodeResult(4) then
                ReadBarCode=BarCodeResult(1)
            else
                ReadBarCode="bar code with errors detected"
            End if
        End If
        If BarCodeResult(0)=5 then 
            If BarCodeResult(1)=BarCodeResult(2) and BarCodeResult(1)=BarCodeResult(3) and BarCodeResult(1)=BarCodeResult(4)  and BarCodeResult(1)=BarCodeResult(5) then
                ReadBarCode=BarCodeResult(1)
            else
                ReadBarCode="bar code with errors detected"
            End if
        End If
        If BarCodeResult(0)=6 then 
            If BarCodeResult(1)=BarCodeResult(2) and BarCodeResult(1)=BarCodeResult(3) and BarCodeResult(1)=BarCodeResult(4)  and BarCodeResult(1)=BarCodeResult(5)   and BarCodeResult(1)=BarCodeResult(6) then
                ReadBarCode=BarCodeResult(1)
            else
                ReadBarCode="bar code with errors detected"
            End if
        End If
        If BarCodeResult(0)=7 then 
            If BarCodeResult(1)=BarCodeResult(2) and BarCodeResult(1)=BarCodeResult(3) and BarCodeResult(1)=BarCodeResult(4)  and BarCodeResult(1)=BarCodeResult(5)   and BarCodeResult(1)=BarCodeResult(6)   and BarCodeResult(1)=BarCodeResult(7) then
                ReadBarCode=BarCodeResult(1)
            else
                ReadBarCode="bar code with errors detected"
            End if
        End If
        If BarCodeResult(0)=8 then 
            If BarCodeResult(1)=BarCodeResult(2) and BarCodeResult(1)=BarCodeResult(3) and BarCodeResult(1)=BarCodeResult(4)  and BarCodeResult(1)=BarCodeResult(5)   and BarCodeResult(1)=BarCodeResult(6)   and BarCodeResult(1)=BarCodeResult(7)   and BarCodeResult(1)=BarCodeResult(8) then
                ReadBarCode=BarCodeResult(1)
            else
                ReadBarCode="bar code with errors detected"
            End if
        End If
        If BarCodeResult(0)=9 then 
            If BarCodeResult(1)=BarCodeResult(2) and BarCodeResult(1)=BarCodeResult(3) and BarCodeResult(1)=BarCodeResult(4)  and BarCodeResult(1)=BarCodeResult(5)   and BarCodeResult(1)=BarCodeResult(6)   and BarCodeResult(1)=BarCodeResult(7)   and BarCodeResult(1)=BarCodeResult(8)   and BarCodeResult(1)=BarCodeResult(9) then
                ReadBarCode=BarCodeResult(1)
            else
                ReadBarCode="bar code with errors detected"
            End if
        End If
        If BarCodeResult(0)=10 then 
            If BarCodeResult(1)=BarCodeResult(2) and BarCodeResult(1)=BarCodeResult(3) and BarCodeResult(1)=BarCodeResult(4)  and BarCodeResult(1)=BarCodeResult(5)   and BarCodeResult(1)=BarCodeResult(6)   and BarCodeResult(1)=BarCodeResult(7)   and BarCodeResult(1)=BarCodeResult(8)   and BarCodeResult(1)=BarCodeResult(10) then
                ReadBarCode=BarCodeResult(1)
            else
                ReadBarCode="bar code with errors detected"
            End if
        End If
        If BarCodeResult(0)=11 then 
            If BarCodeResult(1)=BarCodeResult(2) and BarCodeResult(1)=BarCodeResult(3) and BarCodeResult(1)=BarCodeResult(4)  and BarCodeResult(1)=BarCodeResult(5)   and BarCodeResult(1)=BarCodeResult(6)   and BarCodeResult(1)=BarCodeResult(7)   and BarCodeResult(1)=BarCodeResult(8)   and BarCodeResult(1)=BarCodeResult(10)  and BarCodeResult(1)=BarCodeResult(11) then
                ReadBarCode=BarCodeResult(1)
            else
                ReadBarCode="bar code with errors detected"
            End if
        End If
        
    End Function
    
    Private Sub trbLevelBW_Scroll( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles trbLevelBW.Scroll
        Me.txtLevelBW.Text=Me.trbLevelBW.Value
    End Sub

    Function resultEncoder(ByVal InputCode As String) As String

        '**********************************************************************************************
        '*** encoding the result sting, if possible
        '**********************************************************************************************

        resultEncoder = "error"

        'Bar Codes in Vorwärtsrichtung

        If InputCode = "111221211"  Then
            resultEncoder = "F0"
        End If
        If InputCode = "211211112"  Then
            resultEncoder = "F1"
        End If
        If InputCode = "112211112"  Then
            resultEncoder = "F2"
        End If
        If InputCode = "212211111"  Then
            resultEncoder = "F3"
        End If
        If InputCode = "111221112"  Then
            resultEncoder = "F4"
        End If
        If InputCode = "211221111"  Then
            resultEncoder = "F5"
        End If
        If InputCode = "112221111"  Then
            resultEncoder = "F6"
        End If
        If InputCode = "111211212"  Then
            resultEncoder = "F7"
        End If
        If InputCode = "211211211"  Then
            resultEncoder = "F8"
        End If
        If InputCode = "112211211"  Then
            resultEncoder = "F9"
        End If

        'Bar Codes in Rückwärtsrichtung

        If  InputCode = "112122111" Then
            resultEncoder = "R0"
        End If
        If  InputCode = "211112112" Then
            resultEncoder = "R1"
        End If
        If  InputCode = "211112211" Then
            resultEncoder = "R2"
        End If
        If  InputCode = "111112212" Then
            resultEncoder = "R3"
        End If
        If  InputCode = "211122111" Then
            resultEncoder = "R4"
        End If
        If  InputCode = "111122112" Then
            resultEncoder = "R5"
        End If
        If  InputCode = "111122211" Then
            resultEncoder = "R6"
        End If
        If  InputCode = "212112111" Then
            resultEncoder = "R7"
        End If
        If  InputCode = "112112112" Then
            resultEncoder = "R8"
        End If
        If  InputCode = "112112211" Then
            resultEncoder = "R9"
        End If

    End Function

    Private Sub cmdBarCodeRetry_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles cmdBarCodeRetry.Click

        'clear picture frames an bar code result
        Me.pbxCameraImageMod.Image=nothing
        Me.txtBarCodeResult.Text=""
        
        'new job: analyse bar code
        globJobSequenceNo=globJobSequenceNo+1
        Me.dgvJobList.Rows.Add(globJobSequenceNo,7,"waiting","analyse bar code from camera image",500,now)

        'process pending events
        System.Windows.Forms.Application.DoEvents()

        'start dispatcher
        Me.tmrJobDispatcher.Enabled=true
        
    End Sub

End Class
